#!/usr/local/bin/perl
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin";
# !+-------------------------------------------------------------------------
#    Name:  dbamon_security_report.pl
#  Author:  Bill Border
# Changes:
# !*-------------------------------------------------------------------------

$| = 1;
$P = "dbamon_security_report.pl";
require "cgi_handlers.pl";

# Read WWW_Check:
chop($font = `grep 'WWW_Font:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
if ($font =~ /%/)
{
  $font =~ s/%/ /g;
  $font = "'$font'";
}
$font = "arial" if ! $font;

push(@INC,"/opt/dbamon/lib");
require "subs.pl";
require "subsDB.pl";
require "subsWWW.pl";

# Trap an interrupt signal and clean up
$SIG{'INT'} = 'IntHandler';

use DBI;
require "cgi_handlers.pl";

# General parms required
##$DBdir         = "/var/opt/apache/htdocs/cftasks";
##$modlockfile   = "$DBdir/modlock";
##$entlockfile   = "$DBdir/entlock";
##$conlockfile   = "$DBdir/conlock";
##$modfile       = "$DBdir/modEntries";
##$cfteamFile    = "$DBdir/cfteam";
##$entityFile    = "$DBdir/entities";

$rowcolor = "dcdcdc";

chop($date     = `date`);
chop($host     = `hostname`);
# Save Company name
chop($compwork = `nslookup $host | grep Name: | awk '{ print \$2 }'`) if -e '/etc/resolv.conf';
@words = split(/\./,$compwork);
$nexttolast = $#words - 1;
$company = $words[$nexttolast];

$database = "dbamon";

# See if DBAmon is configured to use Oracle
chop($use_oracle  = `grep Use_Oracle:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_SID  = `grep ORACLE_SID:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_HOME = `grep ORACLE_HOME: /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
if ($use_oracle eq "Y" && $ORACLE_SID ne "" && $ORACLE_HOME ne "")
{
  $ENV{'ORACLE_SID'}  = $ORACLE_SID;
  $ENV{'ORACLE_HOME'} = $ORACLE_HOME;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $ORACLE_SID;
  $dbms = "oracle";
}

#------------------------------------------------------------------------------
sub bg
#------------------------------------------------------------------------------
{
  if ($lastbg == 1)
  {
    $lastbg = 0;
    return "bgcolor=ffffff";
  }
  else
  {
    $lastbg = 1;
    return "bgcolor=$rowcolor";
  }
}

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  print "<br><font size=2>$date ${P} | <b>$msgmsg</b>\n";
}

#-----------------------------------------------------------------------------
sub displayError 
#-----------------------------------------------------------------------------
{
   local($errorMsg) = @_;

   print "Content-type: text/html\n\n";
   print "<head><title> Database Function Error - Output</title></head>";
   print "<body><font face=$font>";

   print "<h2> The following database error occured - $date</h2>";
   print "<hr noshade>";
   print "</hr noshade>";
   print "<h4> $errorMsg</h4>";
   $sqlerror = $DBI::errstr;
   print "<br>SQL statement: $sql";
   print "<br>SQL error: $sqlerror";

   &PrintLinks;

   print "</body>";
   print "</html>";

   exit(1);
}

#-----------------------------------------------------------------------------
sub connectDBOld
#-----------------------------------------------------------------------------
{
  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
         &error('Failed_on_DB_connect_in_updateDb');
}

#-----------------------------------------------------------------------------
sub selectData
#-----------------------------------------------------------------------------
{
  $elapsed = 0;
  $s_time = time;

  if ($orderby_parm eq "S1") { $orderby = "dbms,msgid,system "; }
  if ($orderby_parm eq "S2") { $orderby = "title "; }
  else                       { $orderby = "dbms,msgid,system "; }

  if ($dbamon_repos eq "O")
  {
    $sql  = "select
	  title,
	  dbms,
	  text,
	  msgid,
	  details_url,
	  to_char(ts,\'YYYY/MM/DD-HH24:MI:SS\')
	from
	  dbamon.event_detail
	where
	  dbamonmode like 'prod%' and
	  sev = 'S'
	order by
	  $orderby";
  }
  else
  {
    $sql  = "select
	  title,
	  dbms,
	  text,
	  msgid,
	  details_url,
	  --to_char(ts,\'YYYY/MM/DD-HH24:MI:SS\')
	  dbamon.dateconvert_19(ts)
	from
	  dbamon.event_detail
	where
	  dbamonmode like 'prod%' and
	  sev = 'S'
	order by
	  $orderby";
  }

  ##&msg("sql=$sql");

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $e_time = time;
  $elapsed = $e_time - $s_time;

  print "<p><table border=0 zwidth=80% >\n";
  print "<tr bgcolor=slate>
    <th><h5><a href='$P?S1'>Msgid</a>
    <th><h5>DBMS
    <th><h5><a href='$P?S2'>Server/Instance</a>
    <th><h5>Event
    <th><h5>Event Timestamp
  \n";

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $title  = shift @Data;
    $dbms   = shift @Data;
    $text   = shift @Data;
    $msgid  = shift @Data;
    $url    = shift @Data;
    $ts     = shift @Data;

    $bgcolor = "mediumpurple"; 

    $fs = "2 face=$font";

    $bg = &bg;

    if ($dbms eq "OracleDB-UX") { $dbmscolor = "red"; } 
    else                      { $dbmscolor = "orange"; } 

    if ($orderby =~ /^dbms,msgid/)
    {
      if ($last_msgid && $msgid ne $last_msgid) { print "<tr><td colspan=99><hr> \n"; }
    }
    if ($orderby =~ /^title/)
    {
      if ($last_msgid && $title ne $last_title) { print "<tr><td colspan=99><hr> \n"; }
    }

    print "<tr $bg>
      <td bgcolor=$bgcolor><font size=$fs><h6><a href='http://dbamon.com/errors#$msgid'>$msgid</a></font>
      <td nowrap><font size=$fs color=$dbmscolor><h6>$dbms  </font>
      <td nowrap><font size=$fs><h6>$title</font>
      <td nowrap><font size=$fs><a href='/dbamon/$url'><h6>$text</a>  </font>
      <td nowrap><font size=$fs><h6>$ts    </font>
    ";

    $last_msgid = $msgid;
    $last_title = $title;

    $selectcount++;
  }

  print "<tr><td colspan=99><hr> \n"; 
  print "</table>\n";
  &msg("Total Security Events Selected: $selectcount");
}

#-----------------------------------------------------------------------------
sub IntHandler
#-----------------------------------------------------------------------------
{
   local($Signal) = @_;
   print "Signal=$Signal\n";
   exit(0);
}

#-----------------------------------------------------------------------------
sub error_html 
#-----------------------------------------------------------------------------
{
   $manyerrors = @error_list;
   $str= "" ;
   $str1="";
   $str2="";
   $str4=" <h2>Insufficient or missing information...</h2>";
   $html_str=$str.$str1.$str2.$str1.$str4;
   print "$html_str\n";
   #print "<h2>Insufficient or missing information...";
   print "<br>\n";
   print "Please correct the following:</h2>";
   print "<p>\n";
   print "<hr><ul>\n";
   foreach( @error_list) {
      print "<li> $_\n<br>";
   }
   print "</ul>\n";
   print "<hr>\n";
   if ($manyerrors > 3) {
      print "$manyerrors errors - Having a bad day, are we?<p>\n";
   }
   else {
      print "$manyerrors corrections to make.<p>\n";
   }
      
}

#-----------------------------------------------------------------------------
sub custom_html 
#-----------------------------------------------------------------------------
{

   print "<h1>Thank you for using this input form.</h1>";
   print "<h2>Your request has been sent.</h2>";
   print "<p><hr>\n";
}

#-----------------------------------------------------------------------------
sub CheckForEvilness
#-----------------------------------------------------------------------------
{
  local($woid2check) = @_;
  if (($woid2check =~ /\//) ||
      ($woid2check =~ /\;/) ||
      ($woid2check =~ /\</) ||
      ($woid2check =~ /\>/) ||
      ($woid2check =~ /\*/) ||
      ($woid2check =~ /\|/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\&/) ||
      ($woid2check =~ /\!/) ||
      ($woid2check =~ /\#/) ||
      ($woid2check =~ /\(/) ||
      ($woid2check =~ /\)/) ||
      ($woid2check =~ /\[/) ||
      ($woid2check =~ /\]/) ||
      ($woid2check =~ /\{/) ||
      ($woid2check =~ /\}/) ||
      ($woid2check =~ /\:/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\//) ||
      ($woid2check =~ /\n/) ||
      ($woid2check =~ /\"/))
        {
          print "Content-type: text/html\n\n";
          print "You have entered spurious control characters in a field.\n";
          print "You cannot use any of the following characters:\n";
          print " ;<>*|\'&!#()[]{}:\'/\"";
          print "\n The entry that is suspect is [$woid2check]\n";
          print "Please retry...\n";
          exit;
         }
}

#-----------------------------------------------------------------------------
#
# Main
#
#-----------------------------------------------------------------------------

$logfile = "/tmp/dbamon_hist.log";
unlink($logfile);
chop($CurrentDate = `date`);

&get_request;

@words = split(/,/,$ARGV[0]);
$orderby_parm = $words[0];

if ($prodtest eq "test")
{
  $db = "dbamon_test";
}
else
{
  $db = "dbamon";
}

open(LOG, ">>$logfile" );
print LOG "$CurrentDate - $P dbms=$dbms prodtest=$prodtest\n";

&header("Security Excpetions Report"); 

&msg("Starting - orderby_parm=$orderby_parm company=$company");
##system("echo '' | mailx -s 'monitor--$P ($ENV{'REMOTE_HOST'}) [AUTO]' border\@thecompany.com");

# Connect to DB
&connectDB;

# Connect to DB
&selectData;

&msg("Done");
close(LOG);
exit 0;
