#!/usr/local/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************
# =========================================================
# dbamon_ora_backuprpt.pl
#
# Changes:
# 
#   bb 12Jun00 - Initial
# =========================================================

$debug = 1;

$| = 1;
chop($P = `basename $0`); 
$tmpfl = "/tmp/${P}_$$.txt";

push(@INC,"/opt/apache/cgi-bin/");
require "cgi_handlers.pl";

if ($ARGV[0])
{
  $recipients = "border\@dba.it.thecompany.com"; 
}
else
{
  $recipients = "gda-thecompany-dba\@thecompany.com "; 
}

push(@INC,"/opt/dbamon/adm");

chop($today = `date +%Y/%m/%d`);

chop($ORACLE_SID  = `grep ORACLE_SID:  /opt/dbamon/adm/dbamonrc$modesuf | awk '{ print \$2 }'`);
chop($ORACLE_HOME = `grep ORACLE_HOME: /opt/dbamon/adm/dbamonrc$modesuf | awk '{ print \$2 }'`);
$ENV{'ORACLE_SID'}  = $ORACLE_SID;
$ENV{'ORACLE_HOME'} = $ORACLE_HOME;
$old_path           = $ENV{"PATH"};
$ENV{'PATH'}        = "$ORACLE_HOME/bin:${old_path}";

$ENV{'PATH'} = "/opt/dbamon/bin:$ENV{'PATH'}";
$os = $ENV{"ORACLE_SID"};

$dbc_problem_count = 0;
$ra_count = 0;

$fs = "<font size=2 face='Trebuchet MS'>"; 

$mode = uc $ARGV[0];
if ($mode eq "") { $mode = "prod"; }
#$modelc = lc $mode;

$arg1 = $ARGV[1];
$arg2 = $ARGV[2];
$arg3 = $ARGV[3];
$arg4 = $ARGV[4];
#$arg5 = $ARGV[5];
#$arg6 = $ARGV[6];
#$arg7 = $ARGV[7];
#$arg8 = $ARGV[8];

#------------------------------------------------------------------------------
sub trim
#------------------------------------------------------------------------------
{
  my @out = @_;
  for (@out)
  {
    s/^\s+//;
    s/\s+$//;
  }
  return wantarray ? @out : $out[0];
}

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  if ($debug) { print "$date ${P} | $msgmsg\n"; }
}

#------------------------------------------------------------------------------
sub error
#------------------------------------------------------------------------------
{
  $msg = $_[0];
  &msg("=============================================================");
  &msg("Fatal Error: $msg");
  &msg("=============================================================");
  &msg("Exiting rc=1");
  exit 1;
}

#------------------------------------------------------------------------------
sub connectDB
#------------------------------------------------------------------------------
{
  &msg("Connecting to DB");
  use DBI;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $os;

  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
    &error('Failed_on_DB_connect');
  $dbh->{LongReadLen} = 4000;
}

#-----------------------------------------------------------------------------
sub loadRAC
#-----------------------------------------------------------------------------
{
  &msg("Selecting loadRAC data");

  $sql  = "
    select distinct
      system,
      instance
    from 
      dbamon.instances
    where
      misc1 = 'bkOPSN2_NA' and
      dbamonmode like 'prod%' 
    order by 1,2
  ";

  ##print "$sql\n";

  $sth = $dbh->prepare($sql) || &error('Select_loadRAC');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $serv = $Data[0];
    $inst = $Data[1];

    ($key = "$serv/$inst") =~ s/ //g;

    $rac_instances{$key} = 1;
  }
  &msg("Selected $selectcount rows");

  &msg("DEBUG - array");
  foreach (sort keys %rac_instances)
  {
    &msg("rac_instances{$_}=$rac_instances{$_}");
  }
}

#-----------------------------------------------------------------------------
sub processDBC
#-----------------------------------------------------------------------------
{
  &msg("dbc_filename=$dbc_filename dbms=$dbms host=$host instance=$instance backup_age=$backup_age backup_command=$backup_command monitor=$monitor") if $host =~ /shep/;
  if ($dbms eq "Informix" || $dbms eq "SAP")
  {
    &msg("dbc_filename=$dbc_filename dbms=$dbms This DBMS not being reported");
    return;
  }

  if ($rac_instances{"$host/$instance"})
  {
    &msg("dbc_filename=$dbc_filename dbms=$dbms RAC N2 Instance not being reported");
    return;
  }

  if ($monitor eq "B")
  {
    &msg("dbc_filename=$dbc_filename dbms=$dbms Monitor=B Instance not being reported");
    return;
  }

  if ($mustbeup eq "N")
  {
    &msg("dbc_filename=$dbc_filename dbms=$dbms Must_Be_Up=N Instance not being reported");
    return;
  }

  #---- See what is wrong
  $problem = "";
  if ($monitor eq "N")
  {
    #---- See if there is a risk acceptance for this
    $key = "$hostshort/$title1";
    ##&msg("DEBUG monitorNo{$key}=$monitorNo{$key}");
    if ($monitorNo{$key} && $today lt $monitorNo{$key})
    {
      &msg("dbc_filename=$dbc_filename dbms=$dbms monitorNo Risk Acceptance in effect - expires $monitorNo{$key}");
      $email_ra .= "<tr>
      <td>$fs $dbc_filename
      <td>$fs $dbms / $title1
      <td>$fs Backup_Age=$backup_age Monitor=$monitor
      <td>$fs (monitorNo RA In Effect Until $monitorNo{$key})
      "; 
      $ra_count++;
    }
    else
    {
      $problem = "(Monitor: is N)"; 
    }
  } 
  if ($backup_age eq "N" || $backup_age eq "?")
  {
    #---- See if there is a risk acceptance for this
    $key = "$hostshort/$title1";
    ##&msg("DEBUG backupNo{$key}=$backupNo{$key}");
    if ($backupNo{$key} && $today lt $backupNo{$key})
    {
      &msg("dbc_filename=$dbc_filename dbms=$dbms backupNo Risk Acceptance in effect - expires $backupNo{$key}");
      $email_ra .= "<tr>
      <td>$fs $dbc_filename
      <td>$fs $dbms / $title1 
      <td>$fs Backup_Age=$backup_age Monitor=$monitor
      <td>$fs (backupNo RA In Effect Until $backupNo{$key})
      ";
      $ra_count++;
    }
    else
    {
      $problem .= " (Backup_Age: is N or is not specified)"; 
    }
  } 

  #---- Send detail line
  if ($problem)
  {
    $email_body .= "<tr>
    <td>$fs $dbc_filename
    <td>$fs $dbms / $title1 
    <td>$fs Backup_Age=$backup_age Monitor=$monitor
    <td>$fs $problem 
    "; 

    $email_no_html .= "
DBC_Filename=$dbc_filename  
  Problem=$problem
  Instance=$dbms / $title1  
  Backup_Age=$backup_age Monitor=$monitor \n";

    $dbc_problem_count++;
  }

  #---- Reset vars
  $backup_age = $backup_command = $dbms = $host = $monitor = $instance = $title1 = "?"; 
}

#-----------------------------------------------------------------------------
sub selectDBC
#-----------------------------------------------------------------------------
{
  &msg("Selecting bkDBCOff data");

  $email_body = ""; 

  $statement  = "
    select 
      dbc_filename, 
      dbc_parm,
      dbc_value 
    from 
      dbamon.dbc
    where
      dbc_dbamonmode like 'prod%' and 
      dbc_parm in (
        'Backup_Age:',
        'Backup_Command:',
        'DBMS:',
        'ORACLE_SID:',
        'Host:',
        'Title1:',
        'Monitor:',
        'Must_Be_Up:'
      )
    order by 1, 2, 3
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) || &error('Select_$what');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;

  while (@Data = $sth->fetchrow_array)
  {
    if ($last_dbc_filename && $Data[0] ne $last_dbc_filename)
    {
      &processDBC;
      $backup_age = $backup_command = $dbms = $host = $monitor = $instance = $title1 = $mustbeup = "?"; 
    }

    $selectcount++;

    $dbc_filename = $Data[0];
    $dbc_parm     = $Data[1];
    $dbc_value    = $Data[2];

    print "dbc_parm=$dbc_parm dbc_value=$dbc_value dbc_filename=$dbc_filename\n" if $dbc_filename =~ /shep/;

    if    ($dbc_parm eq "Backup_Age:")     { $backup_age     = $dbc_value; }
    elsif ($dbc_parm eq "Backup_Command:") { $backup_command = $dbc_value; }
    elsif ($dbc_parm eq "DBMS:")           { $dbms           = $dbc_value; }
    elsif ($dbc_parm eq "Host:")           { $host           = $dbc_value; }
    elsif ($dbc_parm eq "Monitor:")        { $monitor        = $dbc_value; }
    elsif ($dbc_parm eq "ORACLE_SID:")     { $instance       = $dbc_value; }
    elsif ($dbc_parm eq "Title1:")         { $title1         = $dbc_value; }
    elsif ($dbc_parm eq "Must_Be_Up:")     { $mustbeup       = $dbc_value; }
    else    { &error("Undefined dbc_parm=$dbc_parm"); }

    $dbms    = "Informix" if $dbms    eq "?";
    $monitor = "Y"        if $monitor eq "?";
  
    $hostshort = (split('\.',$host)) [0];

    $last_dbc_filename = $dbc_filename;
  }

  #---- Process last entry
  &processDBC;

  #---- Report header - main report
  $email .= "
  <h3>Instances With Outstanding <i>Backup_Age:</i> Or <i>Monitor:</i> Risk(s)</h3>
  <table border=1 bgcolor=antiquewhite>
  <tr bgcolor=slate>
    <th>$fs Server / Instance
    <th>$fs DBMS / Title1
    <th>$fs Current Settings
    <th>$fs Problem 
  "; 

  $email .= $email_body;

  $email .= "
  <tr bgcolor=slate>
    <td colspan=99>$fs <b> Total Problem DBC Files: $dbc_problem_count
  </table><hr>"; 

  #---- Report header - RA report
  $email .= "
  <h3>Instances With Accepted <i>Backup_Age:</i> Or <i>Monitor:</i> Risks(s)</h3>
  <table border=1 bgcolor=antiquewhite>
  <tr bgcolor=slate>
    <th>$fs Server / Instance
    <th>$fs DBMS / Title1
    <th>$fs Current Settings
    <th>$fs Problem 
  "; 

  $email .= $email_ra;

  $email .= "
  <tr bgcolor=slate>
    <td colspan=99>$fs <b> Total Risks Accepted: $ra_count
  </table>
  <hr>
  <h3>Risk Acceptance Configuration File: /opt/dbamon/adm/risk_acceptance.pl
  <pre>"; 

  $email .= `cat /opt/dbamon/adm/risk_acceptance.pl`;
  $email .= "</pre>\n";
}

#-----------------------------------------------------------------------------
sub init
#-----------------------------------------------------------------------------
{
  chop($hostname = `hostname`);
  chop($fqhost = `nslookup $hostname | grep Name: | awk '{ print \$2 }'`);
  chop($date = `date`);

  #msg("Opening output DATA file: $tmpfl");
  #system("rm $tmpfl 2>/dev/null");
  #open(DATA, ">$tmpfl") || &error("Can't open output $tmpfl - $!");
}

#-----------------------------------------------------------------------------
sub sendTicket
#-----------------------------------------------------------------------------
{
  # Create mail message
  &msg("Sending email to create ticket");

  $teamname  = "team_database oracle";
  $reqtype   = "database oracle";
  $login     = "csaitsystemsmail";
  $site      = "cs ait-systems";
  $priority  = "3"; 
  $subrequest= "exception monitoring";
  $action    = "troubleshoot/repair";

  open(MAIL, "| dbamon_mailer -m -s 'ticketHub' frontline_bltoutage\@thecompany.com dbadoc\@dba.it.thecompany.com") || &error("Cannot do dbamon_mailer blts");
  ##open(MAIL, "| dbamon_mailer -m -s 'ticketHub' border\@dba.it.thecompany.com") || &error("Cannot do dbamon_mailer blts");

  print MAIL <<END;
#AR-Message-Begin             Do Not Delete This Line
Schema: BLT4.0
Server: gssapp01.cos.thecompany.com
Login: $login
Password:
Action: Submit
# Values: Submit, Query
Format: Short
# Values: Short, Full 
!600000100!: $site
!        2!: DBAmon[DBA000]
!536870915!: DBAmon[DBA000]
!536870916!: 590-3400
!536870917!: team\@theserver.cos.thecompany.com
!536870944!: 999999
!700000000!: $reqtype
!700000100!: $subrequest
!700000200!: 
!720000002!: $hostname 
!610000100!: $action
!610000200!: $priority
!610000000!: new
!        4!: $teamname
!        8!: [DBAmon|DBA001] Instance Monitor/Backup Risk (ProblemCount=$dbc_problem_count)
!536870922!: [DBAmon|DBA001] Instance Monitor/Backup Risk (ProblemCount=$dbc_problem_count)
!536870987!: DBAmon
!536870921!: 0
!536870960!: Instances In Exception Status: 
$email_no_html 
#AR-Message-End             Do Not Delet This Line
END
  close(MAIL);
}

#-----------------------------------------------------------------------------
sub runReport
#-----------------------------------------------------------------------------
{
  &msg("runReport() - Invoking CGI report"); 

  #---- Test
  $s_date = "2006/09/13-00:00:00";
  $e_date = "2006/10/13-23:59:59"; 

  #---- Date arithmetic
  $num_days = 30; 
  $ref_ts_e = time;
  $ref_ts_s = $ref_ts_e - ($num_days * (24*60*60)) + (24*60*60);

  $s_date = substr(&timeToText($ref_ts_s),0,10) . ":00:00:00"; 
  $e_date = substr(&timeToText($ref_ts_e),0,10) . ":00:00:00"; 

  &msg("runReport() - s_date=$s_date e_date=$e_date"); 
  system("echo ' ' | /opt/apache/cgi-bin/dbamon_sla_report.pl 'BatchRpt1,$s_date,$e_date' 2>&1 > $tmpfl 2>&1");
  $email .= `cat $tmpfl | egrep -v 'Content-type:|DEBUG|is being updated|Checking`; 
  &msg("runReport() - Back from CGI"); 

  if (1 == 0)
  {
    &msg("runReport() - Invoking review report"); 
    system("echo ' ' | /opt/apache/cgi-bin/dbamon_sla_report.pl 'Review,All' 2>&1 > $tmpfl 2>&1");
    system("ll $tmpfl"); 
    $email .= `cat $tmpfl | egrep -v 'Content-type:|DEBUG|is being updated|Checking`; 
    &msg("runReport() - Back from CGI"); 
  }

  $email .= "<hr><p>\n"; 
  $email .= "$fs <a href='http://$fqhost/cgi-bin//dbamon_sla_report.pl?Review,All'><b>Click Here for Detail Report</b></a>.\n"; 
}

#------------------------------------------------------------------------------
sub timeToText
#------------------------------------------------------------------------------
{
  $zz_ts = $_[0];
  ($sec,$min,$hour,$mday,$mon,$year) = localtime($zz_ts);
  $year += 1900;
  $mon += 1;

  # Pad with 0's
  $yy = sprintf("%04d",$year);
  $mm = sprintf("%02d",$mon);
  $dd = sprintf("%02d",$mday);
  $hh = sprintf("%02d",$hour);
  $mi = sprintf("%02d",$min);
  $ss = sprintf("%02d",$sec);

  $date = "$yy/$mm/$dd-$hh:$mi:$ss";
  return $date;
}

#------------------------------------------------------------------------------
sub timeToNum
#------------------------------------------------------------------------------
{
  $zz_text = $_[0];
  $zz_text =~ s/-/\//g;
  $zz_text =~ s/:/\//g;
  ##print "zz_text=$zz_text\n";
  @words = split(/\//,$zz_text);

  if ($#words != 5)
  {
    &error("timeToNum() Input timestamp ($zz_text) should be in the format: YYYY/MM/DD-HH:MM:SS");
  }

  $zz_yyyy = $words[0];
  $zz_mon  = $words[1];
  $zz_dd   = $words[2];
  $zz_hh   = $words[3];
  $zz_mm   = $words[4];
  $zz_ss   = $words[5];
  ##print "zz_yyyy=$zz_yyyy zz_mon=$zz_mon zz_dd=$zz_dd zz_hh=$zz_hh zz_mm=$zz_mm zz_ss=$zz_ss\n";

  &error("timeToNum() - ($zz_text) YYYY must be 2002-2099") if ($zz_yyyy < 2002 || $zz_yyyy > 2099);
  &error("timeToNum() - ($zz_text) MON  must be 1-12     ") if ($zz_mon  <    1 || $zz_mon  >   12);
  &error("timeToNum() - ($zz_text) DD   must be 1-31     ") if ($zz_dd   <    1 || $zz_dd   >   31);
  &error("timeToNum() - ($zz_text) HH   must be 0-23     ") if ($zz_hh   <    0 || $zz_hh   >   23);
  &error("timeToNum() - ($zz_text) MM   must be 0-59     ") if ($zz_mm   <    0 || $zz_mm   >   59);
  &error("timeToNum() - ($zz_text) SS   must be 0-59     ") if ($zz_ss   <    0 || $zz_ss   >   59);

  @zz_date=($zz_ss,$zz_mm,$zz_hh,$zz_dd,--$zz_mon,$zz_yyyy);
  $zz_result = &timelocal(@zz_date);

  return $zz_result;
}

#------------------------------------------------------------------------------
#
# Main
#
#------------------------------------------------------------------------------

&msg("Starting mode=$mode arg1=$arg1 arg2=$arg2 arg3=$arg3 arg4=$arg4");

&connectDB;
&init;

$email  = ""; 
$email .= "<br>$fs NOTE: You must be connected to the Thecompany network for Links to be accessible.<p><hr>"; 

&runReport;
chop($subject_data = `cat /tmp/dbamon_sla_report.pl_rpt.txt`); 
chop($color_data = `cat /tmp/dbamon_sla_report.pl_colors.txt`); 

chop($dateshort = `date +%Y/%m/%d`);
$emailhdr = "From: DBCC Team <team\@theserver.cos.thecompany.com>
Content-type: text/html
Subject: ***[DBAmon Report]*** SLA Report - $dateshort - DB Uptime: $color_data $subject_data [AUTO]
<font face='Trebuchet MS' size=2> ";

open(RPT,">$tmpfl");
print RPT $emailhdr;
print RPT $email;
close(RPT);
&msg("Sending report to $recipients"); 
system ("cat $tmpfl | /usr/sbin/sendmail $recipients");

&msg("Done");
exit 0;
