# -----------------------------------------------------------------------------
sub orantBkup
{
  ($thishost) = @_;

  if ($up[$thishost] ne "Y")
  {
    logit("(Down/Inhibited)",$thishost);
    return 1;
  }

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  if ($backup_age[$thishost] eq "" || $backup_age[$thishost] eq "N")
  {
    &logit("Backup Aging not requested for this instance",$thishost);
    return 0;
  }

  if ($up[$thishost] eq "D")
  {
    logit("(No software download)",$thishost);
    return;
  }

  if ($use_repository eq "Y")
  {
    $rc = &baICheck($thishost);
    if ($rc > 0)
    {
      $bainhibit[$thishost]  = 1;
      $bckhours_c[$thishost] = "black";
      $bckhours[$thishost]   = "(I)";
      $msg = sprintf("Backup Age Checking Inhibited - Start: %s End: %s Created: %s User: %s Reason: %s",$bai_sts,$bai_ets,$bai_ts,$bai_user,$bai_reason);
      &logit($msg,$thishost);
      return 0 ;
    }
  }
  else
  {
    logit("Backup Aging Inhibit not possible because Use_Oracle != Y",$thishost);
  }

  &remsh("$perlpath[$thishost] $probe[$thishost] $orasid[$thishost] bkup",$tmpfl3,$thishost);
  &probeLog;

  $bckhours_c[$thishost] = "lime";
  $pgmflag = 0;

  &logDetails($thishost,"<h3>Oracle Backup History</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor><th>$f_s Backup Details</tr>");

  open(TMPFL3,  "$tmpfl3") || &error_msg("Can't open output $tmpfl3 - $!");
  while (<TMPFL3>)
  {
    &parse;
    if ($F1 eq "BckAge:")
    {
      $age = $F2;      # Use the most recent (last) age that we find
      $backup_method_long[$thishost] = $F4;

      if ($backup_method_long[$thishost] =~ /LVL/) { $backup_method_long[$thishost] = "bkRMAN"; }

      # Just in case we exceed, set these vars and make report
      $rounded1 = int($age / 10);
      $rounded1 = $rounded1 * 10;
      $rounded2 = $rounded1 + 9;

      &logDetails($thishost,"<tr><td><h5>$F0");
    }
    if ($F0 =~ /DoneOK/) { $pgmflag = 1; }
  }
  close(TMPFL3);

  &logDetails($thishost,"</table><hr>");

  if (!$pgmflag) 
  {
    system("cat $tmpfl3 | dbamon_mailer -s 'DBAmon orant END_OF_PROBE NF $titleraw[$thishost] LogicErr' $debug_email");
    &event("C",$thishost,"Logic Error - Invoked dbamon_orant.pl Did Not Finish","LogicError","DBA010C",$tmpfl3);
  }

  if ($age == -1)
  {
    &event("C",$thishost,"Backup Never Run - Threshold=$backup_age[$thishost]","BkpNever","DBA810C",$tmpfl3);
  }

  if ($age > $backup_age[$thishost])
  {
    &event("C",$thishost,"$rounded1-$rounded2 Hours Since Last Good Backup (Threshold=$backup_age[$thishost])","BkpAge","DBA812C",$tmpfl3);
    $bckhours_c[$thishost] = "hotpink";
  }

  $bckhours[$thishost] = $age;
  if ($bckhours[$thishost] == -1) 
  {
    $bckhours[$thishost] = "(Never)";
  }

  if ($short eq "")
  {
    $msg = sprintf("OK (%s/%s)",$age,$backup_age[$thishost]);
    &logit($msg,$thishost);
  }
}
# -----------------------------------------------------------------------------
1;
